{% extends "lab_7/layout/base.html" %}
{% block content %}
<section name="mahasiswa-list" id="mahasiswa-list">
    	<div class="container">
        <div class="row">
            <div class="col-md-8 col-lg-8">
                <h2> Mahasiswa Fasilkom</h2>
                <ul class="pagination">
                	<li><a class="btn" onClick="prevPage()"><<</a></li>
				    <li class="active"><a id="page-number">1</a></li>
				    <li><a class="btn" onClick="nextPage()">>></a></li>
                </ul>
                <div id="mahasiswa-entry-group" class="list-group">
                    {% if mahasiswa_list %}
                        {% for mahasiswa in mahasiswa_list %}
                            <a class="list-group-item clearfix mahasiswa-entry">
                                {{ mahasiswa.nama }} ({{ mahasiswa.npm }})
                                <span class="pull-right">
                        <span class="btn btn-xs btn-default" onClick="addFriend('{{ mahasiswa.nama }}', '{{ mahasiswa.npm }}')">
                            Tambah sebagai teman
                        </span>
                    </span>
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Oops!</strong> Tidak ada mahasiswa
                        </div>
                    {% endif %}
                </div>
            </div>
            <div class="col-lg-4">
                <h2> Teman Saya </h2>
                <div class="list-group" id="friend-list">
                    {% if friend_list %}
                        {% for friend in friend_list %}
                            <a class="list-group-item clearfix">
                                {{ friend.friend_name }} ({{ friend.npm }})
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Oops!</strong> Tidak ada teman
                        </div>
                    {% endif %}
                </div>
                <form id="add-friend" action="#">
                    {% csrf_token %}
                    <label for="field_npm">npm</label>
                    <input id="field_npm" type="text" name="npm" class="form-control"/>
                    <label for="field_name">name</label>
                    <input id="field_name" type="text" name="name" class="form-control"/>
                    <button type="submit">Tambah</button>
                </form>
            </div>
        </div>
    </div>
</section>
{% endblock %}

{% block javascript %}
<script>
	var pageNumber = 1;

	var nextPage = function() {
		if (pageNumber <= 68) {
			$.ajax({
				method: "GET",
				url: "{% url 'lab-7:get-mahasiswa-list' %}?page=" + (pageNumber+1),
				dataType: "json",
				success: function(response) {
					pageNumber++;
					if (pageNumber > 68) pageNumber = 68;

					$("#page-number").text(pageNumber);
					$(".mahasiswa-entry").remove();
					response.mahasiswa_list.forEach(function(mahasiswa) {
						html = `<a class="list-group-item clearfix mahasiswa-entry">` + mahasiswa.nama + ` (` + mahasiswa.npm + `)<span class="pull-right"><span class="btn btn-xs btn-default" onClick="addFriend('` + mahasiswa.nama + `', '` + mahasiswa.npm + `')">Tambah sebagai teman</span></span></a>`;
						$("#mahasiswa-entry-group").append(html);
					});
				}
			});
		}
	};

	var prevPage = function() {
		if (pageNumber > 1) {
			$.ajax({
				method: "GET",
				url: "{% url 'lab-7:get-mahasiswa-list' %}?page=" + (pageNumber-1),
				dataType: "json",
				success: function(response) {
					pageNumber--;
					if (pageNumber < 1) pageNumber = 1;

					$("#page-number").text(pageNumber);
					$(".mahasiswa-entry").remove();
					response.mahasiswa_list.forEach(function(mahasiswa) {
						html = `<a class="list-group-item clearfix mahasiswa-entry">` + mahasiswa.nama + ` (` + mahasiswa.npm + `)<span class="pull-right"><span class="btn btn-xs btn-default" onClick="addFriend('` + mahasiswa.nama + `', '` + mahasiswa.npm + `')">Tambah sebagai teman</span></span></a>`;
						$("#mahasiswa-entry-group").append(html);
					});
				}
			});
		}
	};

    var addFriend = function(nama, npm) {
        $.ajax({
            method: "POST",
            url: "{% url "lab-7:add-friend" %}",
            data: { name: nama, npm: npm},
            dataType: "json",
            success : function (friend) {
            	// append friend to list
                html = '<a class="list-group-item clearfix">' +
                    friend.friend_name + ' (' + friend.npm +
                    ')</a>';
                $("#friend-list").append(html);
            },
            error : function (error) {
            	console.log(error);
                alert(error.responseText);
            }
        });
    };

    $("#add-friend").on("submit", function () {
       name = $("#field_name").val();
       npm = $("#field_npm").val();
        addFriend(name, npm);
        event.preventDefault();
    });

    $("#field_npm").change(function () {
        npm = $(this).val();
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:validate-npm" %}',
            data: {
                'npm': npm
            },
            dataType: 'json',
            success: function (data) {
                if (data.is_taken) {
                    alert("Mahasiswa dengan npm seperti ini sudah ada");
                }
            }
        });
    });
</script>
{% endblock %}
